\documentclass[twocolumn,9pt,a4]{article}
\usepackage{graphicx}
\usepackage{rotating}
\usepackage{varioref}
\usepackage{here}
\usepackage{fancyheadings}
\usepackage[pdftex,colorlinks=true,
                      pdfstartview=FitV,
                      linkcolor=blue,
                      citecolor=blue,
                      urlcolor=blue,
          ]{hyperref}
          \pdfinfo{
            /Title      (AIPP01: Project proposal)
            /Author     (Tobias Nielsen)
            /Keywords   (Unmanned Airborn Vehicle)
          }

\title{AIPP01 \\ Project description}
\author{Tobias Nielsen}
\date\today

\begin{document}
\maketitle
\pagestyle{headings}
\section*{Definition of the UAV}
The acronym for \emph{UAV} are numerous, but some of the known ones
and most widely accepted version is \emph{Unmanned Aerial Vehicle},
or \emph{Unmanned Airborne Vehicle}. Even
though the definitions slightly differ, the understanding is the same.

A quick search on the term \emph{UAV} on \emph{google} yields the
following definitions:
\begin{description}
\item[Unmanned Aerial Vehicle]. A powered aerial vehicle sustained in
flight by aerodynamic lift and guided without an on-board crew. It may
be expendable or recoverable, and can fly autonomously or be piloted
remotely. There are two categories of UAVs: drones and RPVs.\\
\href{http://www.rcmicroflight.com/library/glossary.asp}
     {www.rcmicroflight.com/library/glossary.asp}

\item[An Unmanned Aerial Vehicle] (UAV), also called a drone, is a
self-descriptive term used by the US military, the Israeli Defense
Forces and others to describe the latest generations of pilot less
aircraft. Taken literally, the term could describe anything from
kites, through hobbyist radio-controlled aircraft, to cruise missiles
from the V-1 Flying Bomb onwards, but in the military parlance is
restricted to reusable heavier-than-air craft.\\
\href{http://en.wikipedia.org/wiki/UAV} {en.wikipedia.org/wiki/UAV}.
\end{description}

There may exists many different types of \emph{UAV} (which is the way
i will refer to it from now on), but they are mostly divided in to the
groups ``fixed wind'' and ``rotary wings''. In the rest of this proposal i
will be referring to a ``fixed wing'' version when i use the term
\emph{UAV}.

\section*{Problem description}
An intelligent system that is able to control a \emph{UAV}, consists of
many parts. There may at the very top be a strategic planner that
chooses some high-level plans like for instance choosing to fly to
next way-point, holding position since a task is still not complete or
perhaps voiding all presents task and return to base since the fuel
state is perhaps to low for the system to continue\footnote{Known as
\emph{Bingo fuel} state: There is only enough fuel for the airplane to
return to base and make a safe landing}. This may off course differ
quite a lot depending on the demands. A much simpler example is where
the drones are used by the navy for target practice\footnote{The story
appeared in a old number of ``Modelflyve nyt'' from mid nineties - but
the specific issue is lost from my collection, so i can only tell the
story as i recall it}.  In this example the robots are remotely
controlled or more precisely directed by very simple means to pass
through an area where the different parties will try to fire upon the
drone. In this situation the drone is not using a sophisticated AI
engine to decide the path flown - only a course is sent to the drone
which is being tracked by some simple gyro hardware.

\begin{figure}[ht]
\begin{turn}{-90}
\includegraphics[height=\linewidth]{arcsandlines}
\end{turn}
\caption{A route consists of a the basic elements lines and arcs}
\label{fig:arcsandlines}
\end{figure}

Planning a course from $a$ to $b$ can be quite complex since there
might exists a few obstacles along the part in the form of weather
systems that makes flying difficult and fuel consuming, prohibited
airspace's enforced by different airspace classifications (
\href{http://da.wikipedia.org/wiki/Luftrumsklasse}
{da.wikipedia.org/wiki/Luftrumsklasse}
{http://da.wikipedia.org/wiki/Luftrumsklasse}) and simply airspace
traffic. A special case is direct controlled airspace where the drone
is forced to follow direction by the flight controller - but this can
be seen as a different planning problem.

Another issue it the fact that a \emph{UAV} is always moving and therefore
it cannot perform any sharp turns. Therefore a course is described
as a list consisting of straight lines and arcs with a minimum
radius like visualized in figure \vref{fig:arcsandlines}.

For simplicity this can be separated in to two categories:
\begin{itemize}
\item Completely restricted airspace.
\item Airspace with a higher flight cost.
\end{itemize}

\subsection*{Focus}
The focus for this project so far is to make a path planner that
chooses a path using evolutionary algorithms, in an airspace with
different kinds of obstructions. In first attempt we simplify this by
giving the planner some fixed kind of obstacles to avoid.

The plane is a moving item (and in this report, it is running at fixed
speed), therefore it cannot the algorithm to run forever in order to
find an extremely optimized solution. Therefore the amount of runs
available to run the evolutionary algorithm is limited to only 40
generations at which an useful solution \emph{must} exists.

As the plane fly against fixed obstacles, its very easy to decide
where the different obstacles will be at any time and therefore its
also a lot easier to choose a good plan. But in order to repeat and
prepare for an eventual change in the environment, the process of
devising a new plan is performed in an iterative manner.

The next goal for this project is to adapt it to a more dynamic
environment where both moving and fixed position object appears in the
airspace. The moving objects may again appear in two general forms,
one which heading and speed is fixed and one that may move arbitrarily
around.

The first is basically the easiest to prepare for since it can be said
with a rather small tolerance where the object will be at a certain
point in time all the time. The second kind, is a lot more difficult
since the amount of tolerance needed to handle this object may start
out small, but over time will expand as we try to forecasts its
position in the future. On single dynamic objects tolerances can be
visualized as an object with a tolerance zone around it. The zone
indicates a possible position of the foreign object should it choose
to turn in an arbitrary direction. This zone therefore grows the
further we try to forecast the position of this item as the
uncertainty grows. 

I hope to be able to solve for the fixed heading and speed kind of
objects before the end this project.

\section*{Solving the problem}
My idea is to try to implement the proposed solutions for this
scenario from \cite{parallelEA1} and \cite{parallelEA2}. 

The first part has been designing a suitable path representation for
the algorithm to work on. In this design i have made a basic
representation of a path as a series of segments.

A single segments is at this point, the lowest level of representation
for a path segment. All information that is held from this object is
the position of the endpoint relative to the entry point of the segment
and the orientation of the robot as it passes through this exit
point. This simplicity is held so that performing the different
mutation methods will be as simple as possible. (In my initial attempt
i choose embed a very complex set of geometric calculations in this
level, but the result of this was that each time that i had to modify
a segment, i also had to use highly complex methods.)

The paths that are generated is included in a population which handles
some different kinds of mutation which is (currently) as follows:

\begin{description}
\item [Mutate 1 Point] In this scenario, a random point in the graph
  is altered in position and orientation. After wards all the remaining
  segments in the sequence is rotated according to the change in
  orientation. 

\item [Mutate 2 Point] Two points is selected and the segments
  in between is shifted in a random direction.

\item [Mutate Expand] And extra point is added in the sequence in such
  a way that it simply extends orientation in the endpoint of the last
  segment and adds some noise to that in order to keep it random. (I
  have considered to let this expansion happen at an arbitrary segment
  in the path.
  
  Its the intention that a single path should only hold a maximum
  number of segments. This causes the algorithm to not overbuild a
  path, but also its not always able to foresee a path all the way to
  the goal. This may seem confusing, but could be explained with
  foreseeing such a long way in to the future would mean that
  eventually all dynamic elements could be everywhere given the time
  needed. This would probably force the method to try to wander away
  in some completely useless directions because its just try to wander
  away from the tolerances from the other aircrafts. Therefore a
  better way would be to only advance the plan to a certain point and
  from there wait a bit until we have gotton a little further in time so
  that the certainty of the position of foreign dynamic object is
  decreased, and from there try to generate a path again.

\item [Crossover] Cuts two paths in half and divides them between each
  other. A connecting path in between is added which makes sure that
  different paths is still present at the same location up to and from
  their cut point. (This is yet to be thoroughly implemented)

\item [Simple copy] To some extend, it must be possible to let a
  single gene survive to the next generation - perhaps if its the best
  currently, so therefore this raw copy method exists.
\end{description}

Furthermore, its also responsible for handling the actual selection
(but not fitness calculation) of the different paths. The selection is
performed in a manner where all the different paths are sorted in a
\emph{best fit last} manner. Then they are arranged in a small lookup
table so that the best fit will have the largest amount of entries and
the worst only one entry. Then entry's are randomly selected from this
list, causing the best to have the highest fitness to have the best
chance of survival.

The fitness calculation is separate since its the most problem
specific task. I have so far tried some different methods (with the
data i had available) which gave the best fitness (lowest value) from
the length, the distance to goal and distance to one object.
\begin{equation}
  f_{path} = l_{path} + td_{path}^2 + \frac{1}{d_{object}-\delta}
\end{equation}

in this equation, the $f_{path}$ is the total fitness of the path,
$l_{path}$ is the length of the path, $d_{object}$ is the shortest
distance to any object in the scene and $\delta$ is the minimum
distance that a path can have to an object.

Here I will over time become a highly complex scene since its also
here that a much more deepening study of a single path is performed. if
a path for instance included a maneuverer that would be impossible to
perform (To powerful turns), it should be reflected here by setting
an extreme value of the fitness which will indicate that the path
is invalid and should be deleted.

\subsection*{Visualization}
\begin{figure}[ht]
\includegraphics[width=0.9\linewidth]{screendump}
\caption{Screen dump of visualizer}
\label{fig:arcsandlines}
\end{figure}

In parallel this project needs some kind of visualization that can
support the verification of the algorithms as the project
progress. Therefore i have developed a small program with \emph{gtkmm}
(\href{http://www.gtkmm.org/}{http://www.gtkmm.org/}) that is able to
show both a single a path, an entire population and off course a target
to approach.

\section*{Known tasks}
\begin{description}
\item [Generate basic algorithms for crossover and mutations] 
  This has been done to a level where we can progress in to developing
  a better fitness function for the system and find sufficient good
  results.  There still is a few implementation details for the some
  of the mutation methods that needs to be implemented - but the goal
  is to be complete with this by the end of easter.

\item [Algorithms for cost of proposed paths] 
  This is one of the more hot task for this second part of this
  project and is starting to surface now. I expect still to follow
  some of the proposed suggestions for finding best fitness for the
  system since the initial attempts went quite well.

\item [Implementation of the above in a GA framework]
  I have not found a suitable GA framework for this task, and i plan
  to skip this. I was hooping that i could have used some of the graph
  framework provided by \emph{boost.org} but they proved less
  suitable for this scenario.

  I have progressed quite a long way with my own implementation of the
  algorithms, and i have only a few times missed some basic framework
  like functionalities for this system.

\item [Simulator for agent realization]
  The simulator has for now been reduced to a visualization of the
  system since a complete simulation would need to implement a lot of
  details that is highly time consuming.

  I do not expect the time to allow it, but it could be an idea to
  implement it in to an existing flight simulator like
  flightgear.org. But since i don't have any initial knowledge about
  implementing planes like this, i do not expect it to be feasible to
  ``just do''
\item [Reevaluations of system for Evolutionary Algorithms] I am
  somewhat up to date about the details in this area - but i still
  expect to continue reading in this area.

\item [Report writing]
  I'm currently in the progress of (re)writing the section about path
  designs as i have made some major modifications in this area. eg 5
  pages so far (estimated)
\end{description}

\bibliographystyle{unsrt}
\bibliography{references}
\end{document}
